﻿// AutoPrint v0.1.0

// Скрипт Adobe Photoshop для автоматического вывода файла на печать
// Предназначен для совместного использования с VisaForm™ (v2.5.x alpha 80 и выше)
// Автор: Дмитрий ToKis Петренко
//	e-mail: tokis@ukr.net 
//	icq#: 275852004
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var strWatchFolder = 'c:\\'; //место поиска спец. файла (двойные слеши в пути - обязательны!)
var strPrintMeFile = 'printme.jpg'; //файл, который будет использован для печати




//НЕ РЕДАКТИРОВАТЬ НИЖЕ!

var strScriptFolder = new File($.fileName).parent; //путь к папке скрипта
var setsFolder = new Folder(strScriptFolder + '/' + 'sets');

arrPrinters = new Array();
arrPrinters = app.activeDocument.printSettings.printers

var whatPrinter;

//~ templateFamily = 'A';

try{
if(templateFamily != undefined &&  templateFamily != ''){
		var f = new File(strScriptFolder + '/' + 'sets' + '/' +  templateFamily + '.txt');
	
		if(f.open("r")){
				whatPrinter = f.read().toString();
				f.close();
		}
}

ShowDialog();

}catch(e){alert('Ошибка в скрипте AutoPrint' + '\n\n' + 'Описание: ' + e.description + '\n' + 'Линия: ' + e.line, "Ошибка!", 1);}


function ShowDialog() {	
		var result=false;
	
		this.CreateDialog = function() {		
				
				dlg = new Window("dialog", 'Отправка на печать');
								
				dlg.orientation = 'column';
				dlg.alignChildren = 'fill';
				dlg.alignment = 'fill';
				dlg.spacing = 6;
				
				var staticTopMsg = dlg.add("statictext", undefined, 'Печать документа на принтере:')
				
				var ddPrintersList = dlg.add("dropdownlist");
				ddPrintersList.preferredSize.width = 300;
				
				for(var i=0; i<arrPrinters.length; i++){
						var item = ddPrintersList.add("item", arrPrinters[i].toString());
						if(arrPrinters[i].toString() == whatPrinter) ddPrintersList.items[i].selected = true;
				}
				
				var checkStore = dlg.add("checkbox", undefined, 'запомнить этот принтер для шаблонов типа ' + '"' +  templateFamily + '"');
				
				try{d = ddPrintersList.selection.text}catch(e){if(e.number == 21 && arrPrinters.length > 0){ddPrintersList.items[0].selected = true; checkStore.value = true;}}
								
				var line = dlg.add("panel");
				
				var grpBottomRow = dlg.add("group");
				grpBottomRow.orientation = 'row';
				grpBottomRow.alignChildren = 'fill';
				grpBottomRow.alignment = 'center';
				
				
				var btnOk = grpBottomRow.add("button", undefined, 'Печатать');
				btnOk.enabled = arrPrinters.length > 0;
				
				var btnCancel = grpBottomRow.add("button", undefined, 'Отмена');
				
				dlg.defaultElement = btnOk;
				btnOk.active = true;				
				dlg.cancelElement = btnCancel;
				
				btnOk.onClick = function(){
						//сохраним выбранный принтер для этого типа шаблона
						if(checkStore.value){ 
								if(!setsFolder.exists) setsFolder.create();//создаем каталог "sets"
								var f = new File(strScriptFolder + '/' + 'sets' + '/' +  templateFamily + '.txt');
								if(f.open("w")){
										whatPrinter = f.write(arrPrinters[ddPrintersList.selection.index].toString());
										f.close();
								}
						}/////////////////////////////////////////////////////////////////////////////////////////////////////////////
					

					Execute(arrPrinters[ddPrintersList.selection.index].toString());
					
					dlg.close();
				}		
				
				dlg.center();					
				dlg.show();
		}	
		
		this.CreateDialog();
		return  result;
		
}

function Execute(whatPrinter){
		//~ var strScriptFolder = new File($.fileName).parent; //путь к папке скрипта
		var fileWatchFile, strPrintFile, strWhatPrinter = undefined, strPrinterName; //другие переменные

		var docRef = app.activeDocument; //обновим
		var saveFile = new File(strWatchFolder + '/' + strPrintMeFile);

		try{
				if(saveFile.exists) saveFile.remove(); //удалим старый файл для печати
				//сохраним документ в новый файл для печати
				jpgSaveOptions = new JPEGSaveOptions();
				jpgSaveOptions.embedColorProfile = true;
				jpgSaveOptions.quality = 10; //качество jpeg
				docRef.saveAs(saveFile, jpgSaveOptions, true, Extension.LOWERCASE);
				
				RunPrint(saveFile, whatPrinter);//запустим в печать

		}catch(e){alert('Ошибка!' + '\n\n' + e, "Ошибка", 1)}

}



function RunPrint(strPrintFile, strPrinterName) {		
		var strBatFileName = 'print.bat'; //имя генирируемого bat-файла
		var batFile = new File(strWatchFolder + '\\' + strBatFileName);
		
		try{
				batFile.open("w"); 
				//batFile.writeln('@ECHO OFF'); 
				batFile.writeln('rundll32.exe C:\\WINDOWS\\system32\\shimgvw.dll,ImageView_PrintTo /pt' + ' "' + strPrintFile.fsName.toString() + '" "' + strPrinterName +'"'); 
				batFile.close();
				if(batFile.exists) batFile.execute();
		}catch(e){
				alert('Произошла ошибка:' + '\n' + e, "Ошибка!", 1);
		}
}