﻿// InfoField v0.0.3
// Скрипт для совместного использования с VisaForm™ (v2.5.x и выше)
// Предназначен для заливки бланка фото на документы различной информацией, получаемой в процессе работы VisaForm
// Встраивается в работу плагина средствами Процессор Эффектов VisaForm. Триггер – "подготовка бланка"
// Автор: Дмитрий ToKis Петренко
//	e-mail: dimatokis@gmail.com 
//	skype: dimatokis
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var vOpacity = 15;
var vScale =  100;

var sFaceFileName = 'face.tif';
var sOrgnPatternFileName ='Original Pattern.pat';

var arrTagNames = new Array();
var arrTagData = new Array();
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//список имен переменных и их значений. Индексы элементов присваемых значений должны строго совпадать между собой
arrTagNames[0] = "%num%";						  arrTagData[0] = indexNum;
arrTagNames[1] = "%templatedescription%";	   arrTagData[1] = TemplateDescription;
arrTagNames[2] = "%creationdate%";				arrTagData[2] = getCurrentDate().toString();
arrTagNames[3] = "%sysinfo%";					    arrTagData[3] = strProgramName + ' ' + strProgramVersion + ' | ' + strProgramWebSite + ' | ' + strCopyright + ' | ' + strProgramUserName;
arrTagNames[4] = "%presetdescription%";		   arrTagData[4] = strPresetDescription;
arrTagNames[5] = "%facesize%";		               arrTagData[5] = vFaceSizeMM;
arrTagNames[6] = "%headsize%";					   arrTagData[6] = vHeadSizeMM;
arrTagNames[7] = "%headspace%";			  	   arrTagData[7] = vHeadSpaceMM;
arrTagNames[8] = "%photowidth%";			       arrTagData[8] = width_of_layer;
arrTagNames[9] = "%photoheight%";			   arrTagData[9] = height_of_layer;
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

        
        
        var fFaceFile = File(File($.fileName).parent.toString() + '/'  + sFaceFileName);

		if(File(File($.fileName).parent.toString() + '/'  + sOrgnPatternFileName).remove().exists) File(File($.fileName).parent.toString() + '/'  + sOrgnPatternFileName).remove();
		
		if(fFaceFile.exists) open(fFaceFile); //откроем морду
		
		var docRef = app.activeDocument;

		FindTextLayerAndReplace(docRef, arrTagNames, arrTagData);
		
		savePatterns(File(File($.fileName).parent.toString() + '/'  + sOrgnPatternFileName))
		
		makeNewPattern('Pattern_' + indexNum);
		
		docRef.close(SaveOptions.DONOTSAVECHANGES); //close

		MakeFilledLayer();
		
		SetLayerFx();

		deleteAllPatterns();
		
		loadPatterns(File(File($.fileName).parent.toString() + '/'  + sOrgnPatternFileName));	
		
		File(File($.fileName).parent.toString() + '/'  + sOrgnPatternFileName).remove();




///////////////////////////////////////////////////////////////////////////////
// Function: FindTextLayerAndReplace()
// Usage: находит по имени текстовый слой и меняет текст в этом слое
// Params: obj - текущий док. (app.activeDocument)
//			arrTagNames - массив, содержащий искомые имена слоев (теги)
//			arrTagData - массив подставляемых данных (индексы элементов должны четко совпадать с индексами arrTagNames)
///////////////////////////////////////////////////////////////////////////////
function FindTextLayerAndReplace(obj, arrTagNames, arrTagData) {

		for(var i=0; i<arrTagNames.length; i++) {
			try {

					obj.activeLayer = activeDocument.artLayers.getByName(arrTagNames[i]);
					obj.activeLayer.textItem.contents = arrTagData[i];
					obj.activeLayer.name = arrTagData[i];
					if(arrTagData[i] == '') obj.activeLayer.name = i;

					while(activeDocument.artLayers.getByName(arrTagNames[i])){
							obj.activeLayer = activeDocument.artLayers.getByName(arrTagNames[i]);
							obj.activeLayer.textItem.contents = arrTagData[i];
							obj.activeLayer.name = arrTagData[i];
							if(arrTagData[i] == '') obj.activeLayer.name = i;
					}
					
			} catch(e) {
					if(e.number != 1302) { alert(e,e,1); return}; 
			}
		}
} 


function makeNewPattern(strName) {
try{		
		// Save actual document as "Pattern 1" 
		// ======================================================= 
		var id18 = charIDToTypeID( "Mk  " ); 
			var desc3 = new ActionDescriptor(); 
			var id19 = charIDToTypeID( "null" ); 
				var ref1 = new ActionReference(); 
				var id20 = charIDToTypeID( "Ptrn" ); 
				ref1.putClass( id20 ); 
			desc3.putReference( id19, ref1 ); 
			var id21 = charIDToTypeID( "Usng" ); 
				var ref2 = new ActionReference(); 
				var id22 = charIDToTypeID( "Prpr" ); 
				var id23 = charIDToTypeID( "fsel" ); 
				ref2.putProperty( id22, id23 ); 
				var id24 = charIDToTypeID( "Dcmn" ); 
				var id25 = charIDToTypeID( "Ordn" ); 
				var id26 = charIDToTypeID( "Trgt" ); 
				ref2.putEnumerated( id24, id25, id26 ); 
			desc3.putReference( id21, ref2 ); 
			var id27 = charIDToTypeID( "Nm  " ); 
			desc3.putString( id27, strName );                     // defines Pattern and name it "Pattern 1"!? 
		executeAction( id18, desc3, DialogModes.NO );
}catch(e){
		if(e.number != -1) { alert(e,e,1); return}; 
}

}

function savePatterns( file ) { 
		var desc = new ActionDescriptor(); 
		desc.putPath( charIDToTypeID( "null" ), file ); 
			var ref = new ActionReference(); 
			ref.putProperty( charIDToTypeID( "Prpr" ), charIDToTypeID( "Ptrn" ) ); 
			ref.putEnumerated( charIDToTypeID( "capp" ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) ); 
		desc.putReference( charIDToTypeID( "T   " ), ref ); 
	executeAction( charIDToTypeID( "setd" ), desc, DialogModes.NO ); 
}; 
function loadPatterns( file ) { 
		var desc = new ActionDescriptor(); 
			var ref = new ActionReference(); 
			ref.putProperty( charIDToTypeID( "Prpr" ), charIDToTypeID( "Ptrn" ) ); 
			ref.putEnumerated( charIDToTypeID( "capp" ), charIDToTypeID( "Ordn" ), charIDToTypeID( "Trgt" ) ); 
		desc.putReference( charIDToTypeID( "null" ), ref ); 
		desc.putPath( charIDToTypeID( "T   " ), file ); 
		desc.putBoolean( charIDToTypeID( "Appe" ), true ); 
	executeAction( charIDToTypeID( "setd" ), desc, DialogModes.NO ); 
}; 
function deleteAllPatterns() { 
	   var go = true; 
	   while( go ) { 
		  try{ 
			 var desc = new ActionDescriptor(); 
				var list = new ActionList(); 
				   var ref = new ActionReference(); 
				   ref.putIndex( charIDToTypeID( "Ptrn" ), 1 );//when a pattern is deleted the others are reindexed 
				list.putReference( ref); 
			 desc.putList( charIDToTypeID( "null" ), list ); 
			 executeAction( charIDToTypeID( "Dlt " ), desc, DialogModes.NO ); 
		  }catch( e ) { 
			 go = false; 
		  } 
	   } 
};


function MakeFilledLayer() {
		// =======================================================
		var idMk = charIDToTypeID( "Mk  " );
			var desc39 = new ActionDescriptor();
			var idnull = charIDToTypeID( "null" );
				var ref13 = new ActionReference();
				var idLyr = charIDToTypeID( "Lyr " );
				ref13.putClass( idLyr );
			desc39.putReference( idnull, ref13 );
		executeAction( idMk, desc39, DialogModes.NO );

		// =======================================================
		var idFl = charIDToTypeID( "Fl  " );
			var desc40 = new ActionDescriptor();
			var idUsng = charIDToTypeID( "Usng" );
			var idFlCn = charIDToTypeID( "FlCn" );
			var idFrgC = charIDToTypeID( "FrgC" );
			desc40.putEnumerated( idUsng, idFlCn, idFrgC );
		executeAction( idFl, desc40, DialogModes.NO );

}

function SetLayerFx() {
		// =======================================================
		var idsetd = charIDToTypeID( "setd" );
			var desc41 = new ActionDescriptor();
			var idnull = charIDToTypeID( "null" );
				var ref14 = new ActionReference();
				var idLyr = charIDToTypeID( "Lyr " );
				var idOrdn = charIDToTypeID( "Ordn" );
				var idTrgt = charIDToTypeID( "Trgt" );
				ref14.putEnumerated( idLyr, idOrdn, idTrgt );
			desc41.putReference( idnull, ref14 );
			var idT = charIDToTypeID( "T   " );
				var desc42 = new ActionDescriptor();
				var idfillOpacity = stringIDToTypeID( "fillOpacity" );
				var idPrc = charIDToTypeID( "#Prc" );
				desc42.putUnitDouble( idfillOpacity, idPrc, 0.000000 );
				var idLefx = charIDToTypeID( "Lefx" );
					var desc43 = new ActionDescriptor();
					var idScl = charIDToTypeID( "Scl " );
					var idPrc = charIDToTypeID( "#Prc" );
					desc43.putUnitDouble( idScl, idPrc, 416.666667 );
					var idpatternFill = stringIDToTypeID( "patternFill" );
						var desc44 = new ActionDescriptor();
						var idenab = charIDToTypeID( "enab" );
						desc44.putBoolean( idenab, true );
						var idMd = charIDToTypeID( "Md  " );
						var idBlnM = charIDToTypeID( "BlnM" );
						var idNrml = charIDToTypeID( "Nrml" );
						desc44.putEnumerated( idMd, idBlnM, idNrml );
						var idOpct = charIDToTypeID( "Opct" );
						var idPrc = charIDToTypeID( "#Prc" );
						desc44.putUnitDouble( idOpct, idPrc, vOpacity );
						var idPtrn = charIDToTypeID( "Ptrn" );
							var desc45 = new ActionDescriptor();
							var idNm = charIDToTypeID( "Nm  " );
							desc45.putString( idNm, 'Pattern_' + indexNum ); //'Pattern_' + indexNum
							var idIdnt = charIDToTypeID( "Idnt" );
							desc45.putString( idIdnt, "77746172-c634-11de-881a-a49070e1fb21" );
						var idPtrn = charIDToTypeID( "Ptrn" );
						desc44.putObject( idPtrn, idPtrn, desc45 );
						var idScl = charIDToTypeID( "Scl " );
						var idPrc = charIDToTypeID( "#Prc" );
						desc44.putUnitDouble( idScl, idPrc, vScale );
						var idAlgn = charIDToTypeID( "Algn" );
						desc44.putBoolean( idAlgn, true );
						var idphase = stringIDToTypeID( "phase" );
							var desc46 = new ActionDescriptor();
							var idHrzn = charIDToTypeID( "Hrzn" );
							desc46.putDouble( idHrzn, 0.000000 );
							var idVrtc = charIDToTypeID( "Vrtc" );
							desc46.putDouble( idVrtc, 0.000000 );
						var idPnt = charIDToTypeID( "Pnt " );
						desc44.putObject( idphase, idPnt, desc46 );
					var idpatternFill = stringIDToTypeID( "patternFill" );
					desc43.putObject( idpatternFill, idpatternFill, desc44 );
				var idLefx = charIDToTypeID( "Lefx" );
				desc42.putObject( idLefx, idLefx, desc43 );
			var idLyr = charIDToTypeID( "Lyr " );
			desc41.putObject( idT, idLyr, desc42 );
		executeAction( idsetd, desc41, DialogModes.NO );
}


